#include <iostream>
#include <string>
using namespace std;

int main() {
  int n, o, a, b, ab, y, bo=0, ba=0, bb=0, bab=0;
string x;
    cin>>n;
    cin>>o>>a>>b>>ab;
    int m[n][4];
    for(int i=0;i<n;i++)
{
bo=ba=bb=bab=0;
cin>>x>>y;
if(x=="O")
{
o-=y;
bo+=y;
}
if(x=="A")
{
if(a>0 && a>=y && y!=(ba+bb+bab+bo))
{
a-=y-(ba+bb+bab+bo);
ba+=y-(ba+bb+bab+bo);
}
if(a>0 && a<y && y!=(ba+bb+bab+bo))
{
ba+=a;
a=0;
}
if (y!=(ba+bb+bab+bo))
{
o-=y-(ba+bb+bab+bo);
bo+=y-(ba+bb+bab+bo);
}
}
if(x=="B")
{
if(b>0 && b>=y && y!=(ba+bb+bab+bo))
{
b-=y-(ba+bb+bab+bo);
bb+=y-(ba+bb+bab+bo);
}
if(b>0 && b<y && y!=(ba+bb+bab+bo))
{
bb+=b;
b=0;
}
if(y!=(ba+bb+bab+bo))
{
o-=y-(ba+bb+bab+bo);
bo+=y-(ba+bb+bab+bo);
}
}
if(x=="AB")
{
if(ab>0 && ab>=y && y!=(ba+bb+bab+bo))
{
ab-=y-(ba+bb+bab+bo);
bab+=y-(ba+bb+bab+bo);
}
if(ab>0 && ab<y && y!=(ba+bb+bab+bo))
{
bab+=ab;
ab=0;
}
if(b>0 && b>=y && y!=(ba+bb+bab+bo))
{
b-=y-(ba+bb+bab+bo);
bb+=y-(ba+bb+bab+bo);
}
if(b>0 && b<y && y!=(ba+bb+bab+bo))
{
bb+=b;
b=0;
}
if(a>0 && a>=y && y!=(ba+bb+bab+bo))
{
a-=y-(ba+bb+bab+bo);
ba+=y-(ba+bb+bab+bo);
}
if(a>0 && a<y && y!=(ba+bb+bab+bo))
{
ba+=a;
a=0;
}
if(y!=(ba+bb+bab+bo))
{
o-=y-(ba+bb+bab+bo);
bo+=y-(ba+bb+bab+bo);
}
}
m[i][0]=bo;
m[i][1]=ba;
m[i][2]=bb;
m[i][3]=bab;
}
if(o>=0 && a>=0 && b>=0 && ab>=0)
{
cout<<"moguce\n";
for(int i=0;i<n;i++)
{
for(int j=0;j<4;j++)
cout<<m[i][j]<<" ";
cout<<"\n";
}
}
else
{
cout<<"nemoguce";
}
  return 0;
}